"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.ACTION_LIST_HOLE_SPACING = void 0;

var React = _interopRequireWildcard(require("react"));

var _classnames2 = _interopRequireDefault(require("classnames"));

var _excluded = ["children", "asContainer", "spacing", "noSpacing", "spaceBellow", "spacedLarge", "noShrink", "grow", "toEnd", "toRight", "stretch", "equalWidth", "hideOverflow", "className"];

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var ACTION_LIST_HOLE_SPACING = {
  XSMALL: 'xsmall',
  SMALL: 'small'
};
exports.ACTION_LIST_HOLE_SPACING = ACTION_LIST_HOLE_SPACING;

var ActionListHole = function ActionListHole(_ref) {
  var _classnames;

  var children = _ref.children,
      asContainer = _ref.asContainer,
      spacing = _ref.spacing,
      noSpacing = _ref.noSpacing,
      spaceBellow = _ref.spaceBellow,
      spacedLarge = _ref.spacedLarge,
      noShrink = _ref.noShrink,
      grow = _ref.grow,
      toEnd = _ref.toEnd,
      toRight = _ref.toRight,
      stretch = _ref.stretch,
      equalWidth = _ref.equalWidth,
      hideOverflow = _ref.hideOverflow,
      className = _ref.className,
      props = _objectWithoutProperties(_ref, _excluded);

  var actionListHoleClass = (0, _classnames2.default)('sg-actions-list__hole', (_classnames = {
    'sg-actions-list__hole--container': asContainer,
    'sg-actions-list__hole--no-spacing': noSpacing,
    'sg-actions-list__hole--space-bellow': spaceBellow
  }, _defineProperty(_classnames, "sg-actions-list__hole--spaced-".concat(String(spacing)), spacing), _defineProperty(_classnames, 'sg-actions-list__hole--spaced-large', spacedLarge), _defineProperty(_classnames, 'sg-actions-list__hole--no-shrink', noShrink), _defineProperty(_classnames, 'sg-actions-list__hole--grow', grow), _defineProperty(_classnames, 'sg-actions-list__hole--to-end', toEnd), _defineProperty(_classnames, 'sg-actions-list__hole--to-right', toRight), _defineProperty(_classnames, 'sg-actions-list__hole--stretch', stretch), _defineProperty(_classnames, 'sg-actions-list__hole--equal-width', equalWidth), _defineProperty(_classnames, 'sg-actions-list__hole--hide-overflow', hideOverflow), _classnames), className);
  return /*#__PURE__*/React.createElement("div", _extends({}, props, {
    className: actionListHoleClass
  }), children);
};

var _default = ActionListHole;
exports.default = _default;