"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.SIZE = exports.ICON_SIZE = void 0;

var React = _interopRequireWildcard(require("react"));

var _classnames = _interopRequireDefault(require("classnames"));

var _Icon = _interopRequireWildcard(require("../icons/Icon"));

var _utils = require("../utils");

var _excluded = ["size", "border", "spaced", "imgSrc", "className", "link", "ariaLinkLabel", "alt"];

var _ICON_SIZE;

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var SIZE = {
  XS: 'xs',
  S: 's',
  M: 'm',
  L: 'l',
  XL: 'xl',
  XXL: 'xxl'
};
exports.SIZE = SIZE;
var ICON_SIZE = (_ICON_SIZE = {}, _defineProperty(_ICON_SIZE, SIZE.XS, 24), _defineProperty(_ICON_SIZE, SIZE.S, 32), _defineProperty(_ICON_SIZE, SIZE.M, 40), _defineProperty(_ICON_SIZE, SIZE.L, 56), _defineProperty(_ICON_SIZE, SIZE.XL, 80), _defineProperty(_ICON_SIZE, SIZE.XXL, 104), _ICON_SIZE);
exports.ICON_SIZE = ICON_SIZE;

var Avatar = function Avatar(_ref) {
  var _classNames;

  var _ref$size = _ref.size,
      size = _ref$size === void 0 ? SIZE.S : _ref$size,
      _ref$border = _ref.border,
      border = _ref$border === void 0 ? false : _ref$border,
      spaced = _ref.spaced,
      imgSrc = _ref.imgSrc,
      className = _ref.className,
      link = _ref.link,
      ariaLinkLabel = _ref.ariaLinkLabel,
      _ref$alt = _ref.alt,
      alt = _ref$alt === void 0 ? '' : _ref$alt,
      props = _objectWithoutProperties(_ref, _excluded);

  var avatarClass = (0, _classnames.default)('sg-avatar', (_classNames = {}, _defineProperty(_classNames, "sg-avatar--".concat(size), size !== SIZE.S), _defineProperty(_classNames, 'sg-avatar--with-border', border), _classNames), className);
  var isImgSrcDefined = imgSrc !== undefined && imgSrc !== null && imgSrc !== '';
  var imageClass = (0, _classnames.default)('sg-avatar__image', {
    'sg-avatar--spaced': spaced,
    'sg-avatar__image--icon': !isImgSrcDefined
  });

  if (_utils.__DEV__) {
    (0, _utils.invariant)(!(ariaLinkLabel && !link), 'Using `ariaLinkLabel` prop has no effect when `link` prop is not set.');
    (0, _utils.invariant)(!(alt && !isImgSrcDefined), 'Using `alt` prop has no effect when `imgSrc` prop is not set.');
  }

  var avatarContent = /*#__PURE__*/React.createElement("div", _extends({}, props, {
    className: avatarClass
  }), isImgSrcDefined ? /*#__PURE__*/React.createElement("img", {
    className: imageClass,
    src: imgSrc,
    alt: alt
  }) : /*#__PURE__*/React.createElement("div", {
    className: imageClass
  }, /*#__PURE__*/React.createElement(_Icon.default, {
    className: "sg-avatar__icon",
    type: "profile",
    color: _Icon.ICON_COLOR['icon-gray-40'],
    size: ICON_SIZE[size],
    "aria-hidden": "true"
  })));

  if (link !== undefined && link !== '') {
    return /*#__PURE__*/React.createElement("a", {
      href: link,
      "aria-label": ariaLinkLabel,
      className: "sg-avatar__wrapper-link"
    }, avatarContent);
  }

  return avatarContent;
};

var _default = Avatar;
exports.default = _default;