"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.CardCheckboxRoot = exports.CardCheckboxIndicator = exports.CardCheckboxContext = void 0;

var React = _interopRequireWildcard(require("react"));

var _classnames = _interopRequireDefault(require("classnames"));

var _Checkbox = _interopRequireDefault(require("../form-elements/checkbox/Checkbox"));

var _generateRandomString = _interopRequireDefault(require("../../js/generateRandomString"));

var _excluded = ["variant", "color", "className", "children", "width", "height", "style", "checked", "defaultChecked", "disabled", "id", "indeterminate", "invalid", "required", "value", "name", "onChange", "aria-labelledby", "aria-describedby"];

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var CardCheckboxContext = /*#__PURE__*/React.createContext({
  checked: false,
  disabled: false,
  indeterminate: false
});
exports.CardCheckboxContext = CardCheckboxContext;
var CardCheckboxRoot = /*#__PURE__*/React.forwardRef(function (_ref, ref) {
  var _ref$variant = _ref.variant,
      variant = _ref$variant === void 0 ? 'outline' : _ref$variant,
      _ref$color = _ref.color,
      color = _ref$color === void 0 ? 'dark' : _ref$color,
      className = _ref.className,
      children = _ref.children,
      width = _ref.width,
      height = _ref.height,
      style = _ref.style,
      checked = _ref.checked,
      _ref$defaultChecked = _ref.defaultChecked,
      defaultChecked = _ref$defaultChecked === void 0 ? false : _ref$defaultChecked,
      disabled = _ref.disabled,
      id = _ref.id,
      indeterminate = _ref.indeterminate,
      _ref$invalid = _ref.invalid,
      invalid = _ref$invalid === void 0 ? false : _ref$invalid,
      _ref$required = _ref.required,
      required = _ref$required === void 0 ? false : _ref$required,
      value = _ref.value,
      name = _ref.name,
      onChange = _ref.onChange,
      ariaLabelledBy = _ref['aria-labelledby'],
      ariaDescribedBy = _ref['aria-describedby'],
      props = _objectWithoutProperties(_ref, _excluded);

  var isControlled = checked !== undefined;

  var _React$useState = React.useState(isControlled ? checked : defaultChecked),
      _React$useState2 = _slicedToArray(_React$useState, 2),
      isChecked = _React$useState2[0],
      setIsChecked = _React$useState2[1];

  var cardId = React.useMemo(function () {
    return id || (0, _generateRandomString.default)();
  }, [id]);
  var cssVariables = {
    '--card-width': width,
    '--card-height': height
  };
  var onInputChange = React.useCallback(function (e) {
    if (!isControlled) {
      setIsChecked(function (val) {
        return !val;
      });
    }

    if (onChange) onChange(e);
  }, [onChange, isControlled]);
  React.useEffect(function () {
    if (isControlled) {
      setIsChecked(checked);
    }
  }, [checked, isControlled]);
  return /*#__PURE__*/React.createElement(CardCheckboxContext.Provider, {
    value: {
      checked: isChecked,
      indeterminate: indeterminate,
      disabled: disabled
    }
  }, /*#__PURE__*/React.createElement("label", _extends({
    className: (0, _classnames.default)('sg-card-interactive', className),
    style: _objectSpread(_objectSpread({}, style), cssVariables),
    "data-variant": variant,
    "data-color": color,
    "data-checked": indeterminate ? 'mixed' : isChecked,
    "data-invalid": invalid,
    "data-disabled": disabled,
    id: "label-".concat(cardId),
    htmlFor: cardId // On iOS the :active pseudo state is triggered only when there is a touch event set on the HTML element
    // and we use active pseudo class to provide press feedback.
    ,
    onTouchStart: function onTouchStart() {
      return null;
    },
    suppressHydrationWarning: true
  }, props), /*#__PURE__*/React.createElement("input", {
    id: cardId,
    ref: ref,
    className: "sg-card-interactive__input",
    type: "checkbox",
    checked: isChecked,
    disabled: disabled,
    name: name,
    onChange: onInputChange,
    required: required,
    value: value,
    "aria-checked": indeterminate ? 'mixed' : isChecked,
    "aria-invalid": invalid ? true : undefined,
    "aria-labelledby": ariaLabelledBy || "label-".concat(cardId),
    "aria-describedby": ariaDescribedBy,
    suppressHydrationWarning: true
  }), /*#__PURE__*/React.createElement("div", {
    className: "sg-card-interactive__border"
  }, /*#__PURE__*/React.createElement("div", {
    className: "sg-card-interactive__background"
  }, children))));
});
exports.CardCheckboxRoot = CardCheckboxRoot;

var CardCheckboxIndicator = function CardCheckboxIndicator(_ref2) {
  var _ref2$slot = _ref2.slot,
      slot = _ref2$slot === void 0 ? 'top-left' : _ref2$slot,
      style = _ref2.style,
      className = _ref2.className;

  var _React$useContext = React.useContext(CardCheckboxContext),
      checked = _React$useContext.checked,
      disabled = _React$useContext.disabled,
      indeterminate = _React$useContext.indeterminate;

  return /*#__PURE__*/React.createElement("div", {
    className: (0, _classnames.default)('sg-card-interactive__indicator', "sg-card-interactive__indicator--".concat(slot), className),
    style: style
  }, /*#__PURE__*/React.createElement(_Checkbox.default, {
    checked: checked,
    disabled: disabled,
    indeterminate: indeterminate
  }));
};

exports.CardCheckboxIndicator = CardCheckboxIndicator;
var CardCheckbox = Object.assign(CardCheckboxRoot, {
  Indicator: CardCheckboxIndicator
});
CardCheckbox.displayName = 'CardCheckbox';
CardCheckboxIndicator.displayName = 'CardCheckbox.Indicator';
var _default = CardCheckbox;
exports.default = _default;