"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.CardRadioContext = exports.CardRadio = void 0;
exports.CardRadioIndicator = CardRadioIndicator;

var React = _interopRequireWildcard(require("react"));

var _classnames = _interopRequireDefault(require("classnames"));

var _Radio = _interopRequireDefault(require("../form-elements/radio/Radio"));

var _generateRandomString = _interopRequireDefault(require("../../js/generateRandomString"));

var _CardRadioGroupContext = require("./CardRadioGroupContext");

var _excluded = ["variant", "color", "className", "children", "width", "height", "style", "id", "disabled", "required", "invalid", "value", "onChange", "aria-labelledby", "aria-describedby"];

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var CardRadioContext = /*#__PURE__*/React.createContext({
  checked: false,
  disabled: false
});
exports.CardRadioContext = CardRadioContext;
var CardRadio = /*#__PURE__*/React.forwardRef(function (_ref, ref) {
  var _ref$variant = _ref.variant,
      variant = _ref$variant === void 0 ? 'outline' : _ref$variant,
      _ref$color = _ref.color,
      color = _ref$color === void 0 ? 'dark' : _ref$color,
      className = _ref.className,
      children = _ref.children,
      width = _ref.width,
      height = _ref.height,
      style = _ref.style,
      id = _ref.id,
      disabled = _ref.disabled,
      _ref$required = _ref.required,
      required = _ref$required === void 0 ? false : _ref$required,
      _ref$invalid = _ref.invalid,
      invalid = _ref$invalid === void 0 ? false : _ref$invalid,
      value = _ref.value,
      onChange = _ref.onChange,
      ariaLabelledBy = _ref['aria-labelledby'],
      ariaDescribedBy = _ref['aria-describedby'],
      props = _objectWithoutProperties(_ref, _excluded);

  var context = (0, _CardRadioGroupContext.useCardRadioGroupContext)();
  var cardId = React.useMemo(function () {
    return id || (0, _generateRandomString.default)();
  }, [id]);
  var isChecked = context.value === value;
  var isRequired = context.required || required;
  var isDisabled = context.disabled || disabled;
  var isInvalid = context.invalid || invalid;
  var cssVariables = {
    '--card-width': width,
    '--card-height': height
  };

  var handleInputChange = function handleInputChange(e) {
    if (context.onChange) {
      context.onChange(e.target.value);
    }

    if (onChange) {
      onChange(e);
    }
  };

  return /*#__PURE__*/React.createElement(CardRadioContext.Provider, {
    value: {
      checked: isChecked,
      disabled: disabled
    }
  }, /*#__PURE__*/React.createElement("label", _extends({
    className: (0, _classnames.default)('sg-card-interactive', className),
    style: _objectSpread(_objectSpread({}, style), cssVariables),
    "data-variant": variant,
    "data-color": color,
    "data-checked": isChecked,
    "data-invalid": invalid,
    "data-disabled": disabled,
    id: "label-".concat(cardId),
    htmlFor: cardId // On iOS the :active pseudo state is triggered only when there is a touch event set on the HTML element
    // and we use active pseudo class to provide press feedback.
    ,
    onTouchStart: function onTouchStart() {
      return null;
    },
    suppressHydrationWarning: true
  }, props), /*#__PURE__*/React.createElement("input", {
    id: cardId,
    ref: ref,
    className: "sg-card-interactive__input",
    type: "Radio",
    checked: isChecked,
    disabled: isDisabled,
    name: context.name,
    onChange: handleInputChange,
    required: isRequired,
    value: value,
    "aria-invalid": isInvalid,
    "aria-labelledby": ariaLabelledBy || "label-".concat(cardId),
    "aria-describedby": ariaDescribedBy,
    suppressHydrationWarning: true
  }), /*#__PURE__*/React.createElement("div", {
    className: "sg-card-interactive__border"
  }, /*#__PURE__*/React.createElement("div", {
    className: "sg-card-interactive__background"
  }, children))));
});
exports.CardRadio = CardRadio;

function CardRadioIndicator(_ref2) {
  var _ref2$slot = _ref2.slot,
      slot = _ref2$slot === void 0 ? 'top-left' : _ref2$slot,
      style = _ref2.style,
      className = _ref2.className;

  var _React$useContext = React.useContext(CardRadioContext),
      checked = _React$useContext.checked,
      disabled = _React$useContext.disabled;

  return /*#__PURE__*/React.createElement("div", {
    className: (0, _classnames.default)('sg-card-interactive__indicator', "sg-card-interactive__indicator--".concat(slot), className),
    style: style
  }, /*#__PURE__*/React.createElement(_Radio.default, {
    checked: checked,
    disabled: disabled
  }));
}

CardRadioIndicator.displayName = 'CardRadioIndicator';