"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
Object.defineProperty(exports, "ALIGNMENT", {
  enumerable: true,
  get: function get() {
    return _ContentBoxConstants.ALIGNMENT;
  }
});
Object.defineProperty(exports, "SIZE", {
  enumerable: true,
  get: function get() {
    return _ContentBoxConstants.SIZE;
  }
});
exports.default = void 0;

var React = _interopRequireWildcard(require("react"));

var _classnames = _interopRequireDefault(require("classnames"));

var _ContentBoxConstants = require("./ContentBoxConstants");

var _excluded = ["children", "full", "spacedTop", "spacedBottom", "className", "align"];

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var ContentBoxContent = function ContentBoxContent(_ref) {
  var _classNames;

  var children = _ref.children,
      full = _ref.full,
      spacedTop = _ref.spacedTop,
      spacedBottom = _ref.spacedBottom,
      className = _ref.className,
      _ref$align = _ref.align,
      align = _ref$align === void 0 ? _ContentBoxConstants.ALIGNMENT.LEFT : _ref$align,
      props = _objectWithoutProperties(_ref, _excluded);

  var contentBoxClass = (0, _classnames.default)('sg-content-box__content', (_classNames = {
    'sg-content-box__content--full': full,
    'sg-content-box__content--with-centered-text': align === _ContentBoxConstants.ALIGNMENT.CENTER,
    'sg-content-box__content--spaced-top': spacedTop === _ContentBoxConstants.SIZE.NORMAL
  }, _defineProperty(_classNames, "sg-content-box__content--spaced-top-".concat(spacedTop || ''), spacedTop && spacedTop !== _ContentBoxConstants.SIZE.NORMAL), _defineProperty(_classNames, 'sg-content-box__content--spaced-bottom', spacedBottom === _ContentBoxConstants.SIZE.NORMAL), _defineProperty(_classNames, "sg-content-box__content--spaced-bottom-".concat(spacedBottom || ''), spacedBottom && spacedBottom !== _ContentBoxConstants.SIZE.NORMAL), _classNames), className);
  return /*#__PURE__*/React.createElement("div", _extends({}, props, {
    className: contentBoxClass
  }), children);
};

var _default = ContentBoxContent;
exports.default = _default;