"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.COUNTER_VARIANT = exports.COUNTER_SIZE = exports.COUNTER_COLOR = void 0;

var React = _interopRequireWildcard(require("react"));

var _classnames = _interopRequireDefault(require("classnames"));

var _Text = _interopRequireDefault(require("../text/Text"));

var _Flex = _interopRequireDefault(require("../flex/Flex"));

var _Icon = _interopRequireDefault(require("../icons/Icon"));

var _excluded = ["icon", "children", "className", "size", "color", "variant", "withAnimation", "aria-label"];

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var COUNTER_VARIANT = {
  solid: 'solid',
  light: 'light'
};
exports.COUNTER_VARIANT = COUNTER_VARIANT;
var SOLID_COLOR_BACKGROUND_MAP = {
  blue: 'blue-60',
  green: 'green-60',
  indigo: 'indigo-60',
  red: 'red-60',
  yellow: 'yellow-40',
  gray: 'gray-40',
  achromatic: 'black'
};
var SOLID_COLOR_TEXT_MAP = {
  blue: 'text-white',
  green: 'text-white',
  indigo: 'text-white',
  red: 'text-white',
  yellow: 'text-black',
  gray: 'text-black',
  achromatic: 'text-white'
};
var LIGHT_COLOR_BACKGROUND_MAP = {
  blue: 'blue-20',
  green: 'green-20',
  indigo: 'indigo-20',
  red: 'red-20',
  yellow: 'yellow-20',
  gray: 'gray-20',
  achromatic: 'white'
};
var COUNTER_COLOR = {
  BLUE: 'blue',
  GREEN: 'green',
  INDIGO: 'indigo',
  RED: 'red',
  YELLOW: 'yellow',
  GRAY: 'gray',
  ACHROMATIC: 'achromatic'
};
exports.COUNTER_COLOR = COUNTER_COLOR;
var COUNTER_SIZE = {
  XS: 'xs',
  XXS: 'xxs'
};
exports.COUNTER_SIZE = COUNTER_SIZE;

var Counter = function Counter(_ref) {
  var _cx;

  var icon = _ref.icon,
      children = _ref.children,
      className = _ref.className,
      _ref$size = _ref.size,
      size = _ref$size === void 0 ? 'xs' : _ref$size,
      _ref$color = _ref.color,
      color = _ref$color === void 0 ? 'red' : _ref$color,
      _ref$variant = _ref.variant,
      variant = _ref$variant === void 0 ? 'solid' : _ref$variant,
      withAnimation = _ref.withAnimation,
      ariaLabel = _ref['aria-label'],
      props = _objectWithoutProperties(_ref, _excluded);

  var backgroundColor = variant === 'solid' ? SOLID_COLOR_BACKGROUND_MAP[color] : LIGHT_COLOR_BACKGROUND_MAP[color];
  var counterClass = (0, _classnames.default)('sg-counter', (_cx = {}, _defineProperty(_cx, "sg-counter--".concat(String(size)), size), _defineProperty(_cx, "sg-counter--".concat(String(backgroundColor)), backgroundColor), _defineProperty(_cx, 'sg-counter--with-animation', withAnimation), _defineProperty(_cx, 'sg-counter--with-icon', icon), _cx), className);
  var textColor = variant === 'solid' ? SOLID_COLOR_TEXT_MAP[color] : 'text-black';
  var content;
  content = /*#__PURE__*/React.createElement(_Text.default, {
    size: size !== undefined && size !== null && size === 'xxs' ? 'xsmall' : 'small',
    weight: "bold",
    color: textColor,
    className: size === 'xxs' ? 'sg-counter__text' : 'sg-counter__text-spaced',
    "aria-label": ariaLabel
  }, children);

  if (icon) {
    content = /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement(_Flex.default, {
      className: (0, _classnames.default)('sg-counter__icon-container', {
        'sg-counter__icon-container--xxs': size === 'xxs'
      })
    }, /*#__PURE__*/React.createElement(_Icon.default, {
      type: icon,
      size: size === 'xxs' ? 16 : 24,
      color: "icon-black",
      className: "sg-counter__icon",
      "aria-hidden": !!ariaLabel
    })), /*#__PURE__*/React.createElement(_Flex.default, {
      alignItems: "center"
    }, /*#__PURE__*/React.createElement(_Text.default, {
      as: "span",
      weight: "bold",
      size: size !== undefined && size !== null && size === 'xxs' ? 'xsmall' : 'small',
      className: "sg-counter__text",
      "aria-label": ariaLabel
    }, children)));
  }

  return /*#__PURE__*/React.createElement("div", _extends({}, props, {
    className: counterClass
  }), content);
};

var _default = Counter;
exports.default = _default;