"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.SIZE = exports.COLOR = void 0;

var React = _interopRequireWildcard(require("react"));

var _classnames2 = _interopRequireDefault(require("classnames"));

var _Icon = _interopRequireWildcard(require("../icons/Icon"));

var _excluded = ["valid", "invalid", "capitalized", "fullWidth", "value", "size", "color", "className", "options"];

var _ICON_SIZE_MAP;

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var COLOR = {
  DEAFAULT: 'default',
  WHITE: 'white'
};
exports.COLOR = COLOR;
var SIZE = {
  S: 's',
  M: 'm',
  L: 'l'
};
exports.SIZE = SIZE;
var ICON_SIZE_MAP = (_ICON_SIZE_MAP = {}, _defineProperty(_ICON_SIZE_MAP, SIZE.L, 32), _defineProperty(_ICON_SIZE_MAP, SIZE.M, 24), _defineProperty(_ICON_SIZE_MAP, SIZE.S, 16), _ICON_SIZE_MAP);

var getOptionElement = function getOptionElement(_ref) {
  var value = _ref.value,
      text = _ref.text;
  return /*#__PURE__*/React.createElement("option", {
    key: value,
    value: value
  }, text);
};

var Select = /*#__PURE__*/React.forwardRef(function (props, ref) {
  var _classnames;

  var valid = props.valid,
      invalid = props.invalid,
      capitalized = props.capitalized,
      fullWidth = props.fullWidth,
      value = props.value,
      _props$size = props.size,
      size = _props$size === void 0 ? SIZE.M : _props$size,
      color = props.color,
      className = props.className,
      _props$options = props.options,
      options = _props$options === void 0 ? [] : _props$options,
      additionalProps = _objectWithoutProperties(props, _excluded);

  if (valid === true && invalid === true) {
    throw {
      name: 'WrongValidation',
      message: 'Select can be either valid or invalid!'
    };
  }

  var selectClass = (0, _classnames2.default)('sg-select', (_classnames = {
    'sg-select--selected': value,
    'sg-select--valid': valid,
    'sg-select--invalid': invalid,
    'sg-select--capitalized': capitalized,
    'sg-select--full-width': fullWidth
  }, _defineProperty(_classnames, "sg-select--".concat(String(color)), color), _defineProperty(_classnames, "sg-select--".concat(String(size)), size && size !== 'm'), _classnames), className);
  var optionsElements = options.map(function (item, index) {
    if ('options' in item) {
      return /*#__PURE__*/React.createElement("optgroup", {
        key: item.label + index,
        label: item.label
      }, item.options.map(getOptionElement));
    }

    if (item.text || item.value) {
      return getOptionElement(item);
    }

    return null;
  });
  return /*#__PURE__*/React.createElement("div", {
    className: selectClass
  }, /*#__PURE__*/React.createElement("div", {
    className: "sg-select__icon"
  }, /*#__PURE__*/React.createElement(_Icon.default, {
    type: "caret_down",
    color: _Icon.ICON_COLOR['icon-gray-50'],
    size: ICON_SIZE_MAP[size]
  })), /*#__PURE__*/React.createElement("select", _extends({}, additionalProps, {
    className: "sg-select__element",
    value: value,
    ref: ref
  }), optionsElements));
});
Select.displayName = 'Select';
var _default = Select;
exports.default = _default;