"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.TYPE = void 0;

var React = _interopRequireWildcard(require("react"));

var _classnames2 = _interopRequireDefault(require("classnames"));

var _logoUrl = require("../../logo-url");

var _excluded = ["type", "href", "className", "alt", "aria-label"];

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var LOGO_TYPE = {
  BRAINLY: 'brainly',
  EODEV: 'eodev',
  NOSDEVOIRS: 'nosdevoirs',
  ZNANIJA: 'znanija',
  ZNANIJA_PLUS: 'znanija-plus',
  BRAINLY_PLUS: 'brainly-plus',
  BRAINLY_TUTORING: 'brainly-tutoring'
};
var ICONS = {
  brainly: 'brainly-mobile',
  eodev: 'eodev-mobile',
  nosdevoirs: 'nosdevoirs-mobile',
  znanija: 'znanija-mobile',
  'znanija-plus': 'znanija-plus-small',
  'brainly-plus': 'brainly-plus',
  'brainly-tutoring': 'brainly-tutoring'
};

var HomeButton = function HomeButton(_ref) {
  var _ref$type = _ref.type,
      type = _ref$type === void 0 ? LOGO_TYPE.BRAINLY : _ref$type,
      _ref$href = _ref.href,
      href = _ref$href === void 0 ? '#' : _ref$href,
      className = _ref.className,
      _ref$alt = _ref.alt,
      alt = _ref$alt === void 0 ? '' : _ref$alt,
      ariaLabel = _ref['aria-label'],
      props = _objectWithoutProperties(_ref, _excluded);

  var buttonClass = (0, _classnames2.default)('sg-home-button', _defineProperty({}, "sg-home-button--".concat(type), type !== LOGO_TYPE.BRAINLY), className);
  var logoPath = "".concat((0, _logoUrl.getLogoUrl)(type));
  var mobilePath = "".concat((0, _logoUrl.getLogoUrl)(ICONS[type]));
  var defaultAriaLabel = "".concat(type.replace(/-/g, ' '), " home");
  return /*#__PURE__*/React.createElement("a", _extends({}, props, {
    href: href,
    className: buttonClass,
    "aria-label": ariaLabel || defaultAriaLabel
  }), /*#__PURE__*/React.createElement("img", {
    className: "sg-home-button__logo-small",
    src: mobilePath,
    alt: alt
  }), /*#__PURE__*/React.createElement("img", {
    className: "sg-home-button__logo-big",
    src: logoPath,
    alt: alt
  }));
};

var _default = HomeButton;
exports.default = _default;
var TYPE = LOGO_TYPE;
exports.TYPE = TYPE;