"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var React = _interopRequireWildcard(require("react"));

var _react2 = require("@floating-ui/react");

var _utils = require("../utils");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

var usePopover = function usePopover(_ref) {
  var _ref$placement = _ref.placement,
      placement = _ref$placement === void 0 ? 'top' : _ref$placement,
      customId = _ref.customId,
      _ref$defaultOpen = _ref.defaultOpen,
      defaultOpen = _ref$defaultOpen === void 0 ? false : _ref$defaultOpen,
      open = _ref.open,
      _ref$useHover = _ref.useHover,
      useHover = _ref$useHover === void 0 ? true : _ref$useHover,
      _ref$useClick = _ref.useClick,
      useClick = _ref$useClick === void 0 ? true : _ref$useClick,
      _ref$role = _ref.role,
      role = _ref$role === void 0 ? 'dialog' : _ref$role,
      onOpenChange = _ref.onOpenChange;

  var _React$useRef = React.useRef(customId !== null && customId !== void 0 ? customId : "Popover_".concat((0, _utils.generateId)())),
      id = _React$useRef.current;

  var arrowRef = React.useRef(null);
  var isControlled = open !== undefined;

  var _React$useState = React.useState(isControlled ? open : defaultOpen),
      _React$useState2 = _slicedToArray(_React$useState, 2),
      isOpen = _React$useState2[0],
      setIsOpen = _React$useState2[1];

  var _React$useState3 = React.useState(true),
      _React$useState4 = _slicedToArray(_React$useState3, 2),
      hasArrow = _React$useState4[0],
      setHasArrow = _React$useState4[1];

  React.useEffect(function () {
    if (isControlled && open !== isOpen) {
      setIsOpen(open);
    }
  }, [open, isControlled, isOpen]); // Get position specitic params

  var variantParams = React.useMemo(function () {
    var offsetMainAxis = 8;
    var offsetAlignmentAxis = 0;
    var padding = 5;
    var arrowPadding = 16;

    if (hasArrow) {
      offsetMainAxis = 12;
      offsetAlignmentAxis = -8;
    }

    return {
      offset: {
        mainAxis: offsetMainAxis,
        alignmentAxis: offsetAlignmentAxis
      },
      padding: padding,
      arrowPadding: arrowPadding
    };
  }, [hasArrow]);
  var middleware = React.useMemo(function () {
    return [(0, _react2.offset)({
      mainAxis: variantParams.offset.mainAxis,
      alignmentAxis: variantParams.offset.alignmentAxis
    }), (0, _react2.flip)({
      fallbackAxisSideDirection: 'start',
      fallbackPlacements: ['top', 'bottom', 'left', 'right'] // If it doesn't fit anywhere, apply fallback positions

    }), (0, _react2.shift)({
      padding: variantParams.padding
    }), (0, _react2.arrow)({
      element: arrowRef,
      padding: variantParams.arrowPadding
    }), (0, _react2.hide)({
      strategy: 'referenceHidden'
    })];
  }, [variantParams.arrowPadding, variantParams.offset.alignmentAxis, variantParams.offset.mainAxis, variantParams.padding]);

  var handleOpenChange = function handleOpenChange(isOpen) {
    if (isControlled && onOpenChange) onOpenChange(isOpen);else setIsOpen(isOpen);
  };

  var data = (0, _react2.useFloating)({
    open: isOpen,
    onOpenChange: handleOpenChange,
    placement: placement,
    middleware: middleware,
    whileElementsMounted: _react2.autoUpdate
  });
  var hover = (0, _react2.useHover)(data.context, {
    enabled: useHover,
    move: false,
    mouseOnly: true,
    handleClose: (0, _react2.safePolygon)({
      blockPointerEvents: true
    })
  });
  var focus = (0, _react2.useFocus)(data.context);
  var click = (0, _react2.useClick)(data.context, {
    enabled: useClick
  });
  var dismiss = (0, _react2.useDismiss)(data.context);
  var roleInteractions = (0, _react2.useRole)(data.context, {
    role: role
  });
  var interactions = (0, _react2.useInteractions)([hover, focus, click, dismiss, roleInteractions]);

  var _useTransitionStatus = (0, _react2.useTransitionStatus)(data.context, {
    duration: {
      open: 260,
      close: 180
    }
  }),
      isMounted = _useTransitionStatus.isMounted,
      status = _useTransitionStatus.status;

  return React.useMemo(function () {
    return _objectSpread(_objectSpread({
      id: id,
      isOpen: isOpen,
      setIsOpen: setIsOpen,
      arrowRef: arrowRef,
      arrowPadding: variantParams.arrowPadding,
      hasArrow: hasArrow,
      setHasArrow: setHasArrow,
      placement: placement,
      isMounted: isMounted,
      status: status,
      role: role,
      floatingPlacement: data.placement
    }, interactions), data);
  }, [id, isOpen, variantParams.arrowPadding, hasArrow, placement, isMounted, status, data, interactions, role]);
};

var _default = usePopover;
exports.default = _default;