"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var React = _interopRequireWildcard(require("react"));

var IconModule = _interopRequireWildcard(require("../../icons/Icon"));

var _utils = require("../../utils");

var _excluded = ["size", "name", "onChange", "active", "aria-label", "value", "type"];

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var Icon = IconModule.default,
    ICON_COLOR = IconModule.ICON_COLOR;

var Star = function Star(_ref) {
  var size = _ref.size,
      name = _ref.name,
      onChange = _ref.onChange,
      active = _ref.active,
      label = _ref['aria-label'],
      value = _ref.value,
      _ref$type = _ref.type,
      type = _ref$type === void 0 ? 'star' : _ref$type,
      props = _objectWithoutProperties(_ref, _excluded);

  if (_utils.__DEV__) {
    (0, _utils.invariant)(!(!active && name || !active && label || !active && value), 'name/label/value is not working in non-active Star');
  }

  return /*#__PURE__*/React.createElement("span", _extends({}, props, {
    className: "sg-rate-box__star"
  }), active && /*#__PURE__*/React.createElement("input", {
    type: "radio",
    className: "sg-rate-box__radio",
    name: name,
    onChange: onChange,
    value: value,
    "aria-label": label
  }), /*#__PURE__*/React.createElement(Icon, {
    type: type,
    size: size,
    color: ICON_COLOR.ADAPTIVE,
    className: "sg-rate-box__star-icon",
    "aria-hidden": true
  }));
};

var _default = Star;
exports.default = _default;