"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
Object.defineProperty(exports, "COLOR", {
  enumerable: true,
  get: function get() {
    return _Input.COLOR;
  }
});
Object.defineProperty(exports, "SIZE", {
  enumerable: true,
  get: function get() {
    return _Input.SIZE;
  }
});
exports.default = void 0;

var React = _interopRequireWildcard(require("react"));

var _classnames = _interopRequireDefault(require("classnames"));

var _Input = _interopRequireWildcard(require("../form-elements/Input"));

var _Icon = _interopRequireDefault(require("../icons/Icon"));

var _Button = _interopRequireDefault(require("../buttons/Button"));

var _excluded = ["className", "fullWidth", "size", "withRoundButton", "inputClassName", "buttonType"];

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

// TODO: make back to spread (...InputModule.InputPropsType) after flow bump
var Search = function Search(_ref) {
  var _cx;

  var className = _ref.className,
      fullWidth = _ref.fullWidth,
      size = _ref.size,
      _ref$withRoundButton = _ref.withRoundButton,
      withRoundButton = _ref$withRoundButton === void 0 ? false : _ref$withRoundButton,
      inputClassName = _ref.inputClassName,
      buttonType = _ref.buttonType,
      additionalProps = _objectWithoutProperties(_ref, _excluded);

  var baseClassName = 'sg-search';
  var searchClassName = (0, _classnames.default)(baseClassName, (_cx = {}, _defineProperty(_cx, "sg-search--".concat(String(size)), size), _defineProperty(_cx, 'sg-search--full-width', fullWidth), _cx), className);
  return /*#__PURE__*/React.createElement("div", {
    className: searchClassName
  }, /*#__PURE__*/React.createElement(_Input.default, _extends({}, additionalProps, {
    type: "search",
    withIcon: true,
    size: size,
    className: (0, _classnames.default)("".concat(baseClassName, "__input"), inputClassName),
    fullWidth: true
  })), /*#__PURE__*/React.createElement("div", {
    className: (0, _classnames.default)(["".concat(baseClassName, "-icon-wrapper"), "".concat(baseClassName, "-icon-wrapper--").concat(size)])
  }, /*#__PURE__*/React.createElement(_Button.default, {
    variant: withRoundButton ? 'solid' : 'transparent-light',
    className: (0, _classnames.default)(["".concat(baseClassName, "__icon"), "".concat(baseClassName, "__icon--").concat(size), _defineProperty({}, "".concat(baseClassName, "__icon--transparent"), !withRoundButton)]),
    icon: /*#__PURE__*/React.createElement(_Icon.default, {
      type: "search",
      size: size === 'l' ? 24 : 16,
      color: "adaptive"
    }),
    iconOnly: true,
    size: size === 'l' ? 'm' : 's',
    type: buttonType
  })));
};

var _default = Search;
exports.default = _default;