"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var React = _interopRequireWildcard(require("react"));

var _classnames = _interopRequireDefault(require("classnames"));

var _SubjectIcon = _interopRequireDefault(require("../subject-icons/SubjectIcon"));

var _Icon = _interopRequireDefault(require("../icons/Icon"));

var _Checkbox = _interopRequireDefault(require("../form-elements/checkbox/Checkbox"));

var _Text = _interopRequireDefault(require("../text/Text"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

var SelectMenuOption = /*#__PURE__*/React.forwardRef(function (_ref, ref) {
  var option = _ref.option,
      isSelected = _ref.isSelected,
      _ref$withIcon = _ref.withIcon,
      withIcon = _ref$withIcon === void 0 ? false : _ref$withIcon,
      _ref$multiSelect = _ref.multiSelect,
      multiSelect = _ref$multiSelect === void 0 ? false : _ref$multiSelect,
      interactions = _ref.interactions,
      tabIndex = _ref.tabIndex;

  var _React$useState = React.useState(false),
      _React$useState2 = _slicedToArray(_React$useState, 2),
      isHovered = _React$useState2[0],
      setIsHovered = _React$useState2[1];

  var value = option.value,
      label = option.label,
      icon = option.icon;
  var classNames = (0, _classnames.default)('sg-select-menu__option', {
    'sg-select-menu__option--selected': isSelected,
    'sg-select-menu__option--with-icon': withIcon,
    'sg-select-menu__option--multi-select': multiSelect
  });
  var displayedIcon = React.useMemo(function () {
    var _ref2 = icon || {},
        name = _ref2.name,
        _ref2$isSubjectIcon = _ref2.isSubjectIcon,
        isSubjectIcon = _ref2$isSubjectIcon === void 0 ? false : _ref2$isSubjectIcon;

    if (!withIcon || withIcon && !name) return null;

    if (isSubjectIcon) {
      var subjectIconName = name;
      return /*#__PURE__*/React.createElement(_SubjectIcon.default, {
        size: "small",
        monoColor: isSelected || isHovered ? null : 'icon-gray-50',
        type: subjectIconName
      });
    } else {
      var regularIconName = name;
      return /*#__PURE__*/React.createElement(_Icon.default, {
        size: 24,
        color: isSelected || isHovered ? 'icon-black' : 'icon-gray-50',
        type: regularIconName
      });
    }
  }, [isSelected, isHovered, withIcon, icon]);
  var optionState = React.useMemo(function () {
    var optionState;

    if (multiSelect) {
      optionState = /*#__PURE__*/React.createElement(_Checkbox.default, {
        id: option.value,
        checked: isSelected
      });
    } else if (isSelected) {
      optionState = /*#__PURE__*/React.createElement(_Icon.default, {
        type: "check",
        size: 24,
        color: "icon-black"
      });
    }

    return /*#__PURE__*/React.createElement("div", {
      className: "sg-select-menu__option-state",
      "aria-hidden": true
    }, optionState);
  }, [isSelected, multiSelect, option.value]);
  return /*#__PURE__*/React.createElement("div", _extends({
    key: value,
    ref: ref,
    className: classNames,
    role: "option",
    "aria-selected": isSelected,
    tabIndex: tabIndex
  }, interactions, {
    onMouseEnter: function onMouseEnter() {
      return setIsHovered(true);
    },
    onMouseLeave: function onMouseLeave() {
      return setIsHovered(false);
    }
  }), /*#__PURE__*/React.createElement("div", {
    className: "sg-select-menu__option-label"
  }, displayedIcon, /*#__PURE__*/React.createElement(_Text.default, {
    size: "small",
    weight: "bold",
    breakWords: true
  }, label)), optionState);
});
var _default = SelectMenuOption;
exports.default = _default;