"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var React = _interopRequireWildcard(require("react"));

var _react2 = require("@floating-ui/react");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

var CONTAINER_MARGIN = 10;
var MAX_POPUP_WIDTH = 320;

var useFloatingSelectMenu = function useFloatingSelectMenu(props) {
  var isExpanded = props.isExpanded,
      onOpenChange = props.onOpenChange;

  var _React$useState = React.useState(null),
      _React$useState2 = _slicedToArray(_React$useState, 2),
      activeIndex = _React$useState2[0],
      setActiveIndex = _React$useState2[1];

  var listRef = React.useRef([]);

  var _useFloating = (0, _react2.useFloating)({
    open: isExpanded,
    placement: 'bottom-start',
    onOpenChange: onOpenChange,
    middleware: [(0, _react2.offset)(8), (0, _react2.flip)(), // Apply shift when we want to move component to the side to fit
    (0, _react2.shift)(), (0, _react2.size)({
      apply: function apply(_ref) {
        var elements = _ref.elements,
            availableHeight = _ref.availableHeight,
            availableWidth = _ref.availableWidth;
        Object.assign(elements.floating.style, {
          maxHeight: "".concat(availableHeight - CONTAINER_MARGIN, "px"),
          maxWidth: "".concat(Math.min(availableWidth, MAX_POPUP_WIDTH), "px") // the max width cannot be wider than 320px

        });
      }
    })]
  }),
      x = _useFloating.x,
      y = _useFloating.y,
      strategy = _useFloating.strategy,
      refs = _useFloating.refs,
      context = _useFloating.context,
      placement = _useFloating.placement;

  var _useTransitionStatus = (0, _react2.useTransitionStatus)(context, {
    duration: {
      open: 320,
      close: 250
    }
  }),
      isMounted = _useTransitionStatus.isMounted,
      status = _useTransitionStatus.status;

  var click = (0, _react2.useClick)(context);
  var dismiss = (0, _react2.useDismiss)(context, {
    referencePress: true,
    referencePressEvent: 'click'
  });
  var role = (0, _react2.useRole)(context, {
    role: 'listbox'
  });
  var listNav = (0, _react2.useListNavigation)(context, {
    listRef: listRef,
    activeIndex: activeIndex,
    onNavigate: setActiveIndex,
    // This is a large list, allow looping.
    loop: true,
    focusItemOnHover: false
  });

  var _useInteractions = (0, _react2.useInteractions)([click, dismiss, role, listNav]),
      getReferenceProps = _useInteractions.getReferenceProps,
      getFloatingProps = _useInteractions.getFloatingProps,
      getItemProps = _useInteractions.getItemProps;

  return {
    interactions: {
      getReferenceProps: getReferenceProps,
      getFloatingProps: getFloatingProps,
      getItemProps: getItemProps
    },
    floatingProps: {
      x: x,
      y: y,
      strategy: strategy,
      placement: placement
    },
    refs: refs,
    listRef: listRef,
    context: context,
    isMounted: isMounted,
    status: status,
    activeIndex: activeIndex
  };
};

var _default = useFloatingSelectMenu;
exports.default = _default;