"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
Object.defineProperty(exports, "SPINNER_COLOR", {
  enumerable: true,
  get: function get() {
    return _Spinner.SPINNER_COLOR;
  }
});
Object.defineProperty(exports, "SPINNER_SIZE", {
  enumerable: true,
  get: function get() {
    return _Spinner.SPINNER_SIZE;
  }
});
exports.default = void 0;

var React = _interopRequireWildcard(require("react"));

var _Spinner = _interopRequireWildcard(require("../spinner/Spinner"));

var _classnames = _interopRequireDefault(require("classnames"));

var _excluded = ["loading", "color", "fullWidth", "size", "children", "ariaStatusLabel", "aria-live"];

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var SpinnerContainer = function SpinnerContainer(_ref) {
  var loading = _ref.loading,
      color = _ref.color,
      fullWidth = _ref.fullWidth,
      size = _ref.size,
      children = _ref.children,
      _ref$ariaStatusLabel = _ref.ariaStatusLabel,
      ariaStatusLabel = _ref$ariaStatusLabel === void 0 ? {
    loaded: 'content loaded',
    loading: 'content is loading'
  } : _ref$ariaStatusLabel,
      _ref$ariaLive = _ref['aria-live'],
      ariaLive = _ref$ariaLive === void 0 ? 'assertive' : _ref$ariaLive,
      props = _objectWithoutProperties(_ref, _excluded);

  var childrenWithAriaBusy = React.useMemo(function () {
    if (!loading) {
      return children;
    }

    return React.Children.map(children, function (child) {
      if ( /*#__PURE__*/React.isValidElement(child)) {
        return /*#__PURE__*/React.cloneElement(child, {
          // @ts-expect-error ts migration
          'aria-busy': loading
        });
      }

      return child;
    });
  }, [children, loading]);
  return /*#__PURE__*/React.createElement("div", _extends({}, props, {
    className: (0, _classnames.default)('sg-spinner-container', {
      'sg-spinner-container--full-width': fullWidth
    })
  }), loading ? /*#__PURE__*/React.createElement("div", {
    className: "sg-spinner-container__overlay"
  }, /*#__PURE__*/React.createElement(_Spinner.default, {
    color: color,
    size: size,
    "aria-label": ariaStatusLabel.loading,
    "aria-live": ariaLive
  })) : /*#__PURE__*/React.createElement("span", {
    className: "sg-visually-hidden",
    "aria-live": ariaLive,
    role: "status",
    "aria-atomic": "true"
  }, ariaStatusLabel.loaded), childrenWithAriaBusy);
};

var _default = SpinnerContainer;
exports.default = _default;