"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var React = _interopRequireWildcard(require("react"));

var _TooltipElement = _interopRequireDefault(require("./TooltipElement"));

var _TooltipTrigger = _interopRequireDefault(require("./TooltipTrigger"));

var _useTooltipContext = require("./useTooltipContext");

var _useTooltip = _interopRequireDefault(require("./useTooltip"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var Tooltip = function Tooltip(_ref) {
  var children = _ref.children,
      placement = _ref.placement,
      id = _ref.id,
      size = _ref.size,
      color = _ref.color,
      asLabel = _ref.asLabel,
      _ref$defaultOpen = _ref.defaultOpen,
      defaultOpen = _ref$defaultOpen === void 0 ? false : _ref$defaultOpen,
      open = _ref.open,
      onOpenChange = _ref.onOpenChange;
  var tooltip = (0, _useTooltip.default)({
    placement: placement,
    customId: id,
    size: size,
    color: color,
    defaultOpen: defaultOpen,
    open: open,
    onOpenChange: onOpenChange,
    asLabel: asLabel
  });
  return /*#__PURE__*/React.createElement(_useTooltipContext.TooltipContext.Provider, {
    value: tooltip
  }, children);
};

Tooltip.Trigger = _TooltipTrigger.default;
Tooltip.Element = _TooltipElement.default;
var _default = Tooltip;
exports.default = _default;