"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var React = _interopRequireWildcard(require("react"));

var _classnames = _interopRequireDefault(require("classnames"));

var _react2 = require("@floating-ui/react");

var _Text = _interopRequireDefault(require("../text/Text"));

var _useTooltipContext = _interopRequireDefault(require("./useTooltipContext"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var ARROW_SIZE_DEFAULT = 24;
var ARROW_SIZE_SMALL = 12;
var ARROW_SVG_PATH_DEFAULT = 'M0 24C1.72106 24 3.38535 23.3843 4.69205 22.2642L11.026 16.8349C11.5868 16.3542 12.414 16.3533 12.9759 16.8327L19.3782 22.2961C20.667 23.3958 22.3057 24 24 24V24L0 24V24Z';
var ARROW_SVG_PATH_SMALL = 'M0 12C0.86053 12 1.69267 11.6922 2.34602 11.1321L5.51299 8.41745C5.79338 8.17711 6.20701 8.17665 6.48794 8.41637L9.6891 11.148C10.3335 11.6979 11.1529 12 12 12L0 12Z';
var TooltipElement = /*#__PURE__*/React.forwardRef(function (props, ref) {
  var _context$refs$floatin, _classNames, _context$y, _context$x, _context$middlewareDa;

  var className = props.className,
      label = props.label;
  var context = (0, _useTooltipContext.default)();
  var elementRef = (0, _react2.useMergeRefs)([context.refs.setFloating, ref]);
  var arrowSize = context.size === 'small' ? ARROW_SIZE_SMALL : ARROW_SIZE_DEFAULT;
  var arrowSVGPath = context.size === 'small' ? ARROW_SVG_PATH_SMALL : ARROW_SVG_PATH_DEFAULT;
  var isShorterThanArrowWithPadding = arrowSize + 2 * context.arrowPadding > ((_context$refs$floatin = context.refs.floating.current) === null || _context$refs$floatin === void 0 ? void 0 : _context$refs$floatin.offsetHeight); // If the placement is right or left
  // and the tooltip isn't high enough to fit an arrow with the padding
  // position the arrow individually.
  // We don't care for top and bottom, because the component min width is enough to fit both arrow and it's padding.

  var arrowOffset = isShorterThanArrowWithPadding && (context.placement.includes('right') || context.placement.includes('left')) ? "calc(50% - ".concat(arrowSize / 2, "px)") : null;
  var tooltipClass = (0, _classnames.default)('sg-tooltip', (_classNames = {}, _defineProperty(_classNames, "sg-tooltip--".concat(String(context.size)), context.size), _defineProperty(_classNames, "sg-tooltip--".concat(String(context.color)), context.color), _classNames), className);
  return context.isMounted && /*#__PURE__*/React.createElement(_react2.FloatingPortal, null, /*#__PURE__*/React.createElement("div", _extends({
    ref: elementRef,
    className: tooltipClass,
    "data-tooltip-id": context.id,
    "data-placement": context.floatingPlacement,
    "data-status": context.status,
    style: _objectSpread({
      position: context.strategy,
      top: (_context$y = context.y) !== null && _context$y !== void 0 ? _context$y : 0,
      left: (_context$x = context.x) !== null && _context$x !== void 0 ? _context$x : 0,
      visibility: (_context$middlewareDa = context.middlewareData.hide) !== null && _context$middlewareDa !== void 0 && _context$middlewareDa.referenceHidden ? 'hidden' : 'visible'
    }, props.style),
    "aria-hidden": "true"
  }, context.getFloatingProps(), {
    role: "none"
  }), /*#__PURE__*/React.createElement(_Text.default, {
    className: "sg-tooltip__label",
    align: "to-center",
    color: context.color === 'dark' ? 'text-white' : 'text-black',
    size: "small"
  }, label), /*#__PURE__*/React.createElement(_react2.FloatingArrow, {
    ref: context.arrowRef,
    className: "sg-tooltip__arrow",
    context: context.context,
    width: arrowSize,
    height: arrowSize,
    staticOffset: arrowOffset,
    d: arrowSVGPath
  })));
});
var _default = TooltipElement;
exports.default = _default;