"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.FillMode = void 0;

var React = _interopRequireWildcard(require("react"));

var _hex = _interopRequireDefault(require("../../colors/hex"));

var _Flex = _interopRequireDefault(require("../../flex/Flex"));

var _Text = _interopRequireDefault(require("../../text/Text"));

var _Button = _interopRequireDefault(require("../../buttons/Button"));

var _Transition = _interopRequireDefault(require("../Transition"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

var fillModes = ['none', 'forwards', 'backwards', 'both'];
var shrinkFadeEffect = {
  initial: {
    opacity: 0
  },
  animate: {
    opacity: 1,
    transform: {
      scale: 0.25
    },
    duration: 1000,
    easing: 'entry'
  },
  exit: {
    opacity: 0,
    duration: 1000,
    easing: 'exit'
  }
};

var FillMode = function FillMode() {
  var _React$useState = React.useState(false),
      _React$useState2 = _slicedToArray(_React$useState, 2),
      active = _React$useState2[0],
      setActive = _React$useState2[1];

  return /*#__PURE__*/React.createElement(_Flex.default, {
    className: "sg-space-y-s",
    direction: "column",
    alignItems: "center",
    style: {
      width: 'min-content'
    }
  }, /*#__PURE__*/React.createElement(_Flex.default, {
    className: "sg-space-x-l",
    marginBottom: "m"
  }, fillModes.map(function (mode) {
    return /*#__PURE__*/React.createElement(Container, {
      key: mode,
      description: mode
    }, /*#__PURE__*/React.createElement(_Transition.default, {
      active: active,
      effect: shrinkFadeEffect,
      fillMode: mode,
      delay: 1000
    }, /*#__PURE__*/React.createElement(Circle, null)));
  })), /*#__PURE__*/React.createElement(_Button.default, {
    variant: "solid",
    onClick: function onClick() {
      return setActive(function (b) {
        return !b;
      });
    },
    fullWidth: true
  }, active ? 'hide' : 'show'), /*#__PURE__*/React.createElement(_Text.default, {
    size: "small",
    color: "text-gray-50",
    align: "to-center"
  }, "Activating transition spawns a shrinking circle inside the parent container with a 1s delay."));
};

exports.FillMode = FillMode;

var Circle = function Circle() {
  return /*#__PURE__*/React.createElement("div", {
    style: {
      width: 64,
      height: 64,
      backgroundColor: _hex.default['blue-40'],
      borderRadius: '50%'
    }
  });
};

var Container = function Container(_ref) {
  var description = _ref.description,
      children = _ref.children;
  return /*#__PURE__*/React.createElement(_Flex.default, {
    direction: "column",
    alignItems: "center",
    className: "sg-space-y-m"
  }, /*#__PURE__*/React.createElement("div", {
    style: {
      position: 'relative',
      width: 64,
      height: 64
    }
  }, /*#__PURE__*/React.createElement("div", {
    style: {
      outline: "1px solid ".concat(_hex.default['indigo-50'])
    }
  }, children)), /*#__PURE__*/React.createElement(_Text.default, {
    size: "small"
  }, description));
};

FillMode.parameters = {
  layout: 'centered'
};