"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.FluidList = void 0;

var React = _interopRequireWildcard(require("react"));

var _Button = _interopRequireDefault(require("../../buttons/Button"));

var _Transition = _interopRequireDefault(require("../Transition"));

var _DummyBox = _interopRequireDefault(require("./common/DummyBox"));

var _Stage = _interopRequireDefault(require("./common/Stage"));

var _useIsomorphicLayoutEffect = require("../../utils/useIsomorphicLayoutEffect");

var _useTransformationState = require("./common/useTransformationState");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null) return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

var appearingEffect = {
  initial: {
    opacity: 0,
    transform: {
      scale: 0.9
    }
  },
  animate: {
    opacity: 1,
    duration: 'moderate1'
  }
};
var removingEffect = {
  animate: {
    opacity: 0,
    duration: 'quick2'
  }
};
var initialItemIds = [0, 1, 2, 3];
/**
 * It is greater than the ID of the last initial item to
 * not animate the already added items at the beginning.
 */

var lastUniqueId = initialItemIds.length;

var FluidList = function FluidList() {
  var containerRef = React.useRef(null);

  var _React$useState = React.useState(initialItemIds),
      _React$useState2 = _slicedToArray(_React$useState, 2),
      itemIds = _React$useState2[0],
      setItemIds = _React$useState2[1];

  var addItem = function addItem() {
    setItemIds(function (prev) {
      return [++lastUniqueId].concat(_toConsumableArray(prev));
    });
  };

  var removeItem = function removeItem(id) {
    setItemIds(function (prev) {
      return prev.filter(function (n) {
        return n !== id;
      });
    });
  };

  return /*#__PURE__*/React.createElement(_Stage.default, {
    ref: containerRef,
    className: "sg-space-y-xs",
    format: "portrait"
  }, /*#__PURE__*/React.createElement(_Button.default, {
    variant: "outline",
    onClick: addItem,
    fullWidth: true
  }, "add item"), itemIds.map(function (id, index) {
    return /*#__PURE__*/React.createElement(FluidListItem, {
      key: id,
      index: index,
      updateKey: itemIds.length,
      containerRef: containerRef,
      lastCreated: id === lastUniqueId,
      siblingsAmount: itemIds.length - 1,
      onRemove: function onRemove() {
        return removeItem(id);
      }
    });
  }));
};

exports.FluidList = FluidList;

var FluidListItem = function FluidListItem(_ref) {
  var index = _ref.index,
      updateKey = _ref.updateKey,
      containerRef = _ref.containerRef,
      lastCreated = _ref.lastCreated,
      siblingsAmount = _ref.siblingsAmount,
      onRemove = _ref.onRemove;

  var _React$useState3 = React.useState(false),
      _React$useState4 = _slicedToArray(_React$useState3, 2),
      removing = _React$useState4[0],
      setRemoving = _React$useState4[1];

  var _React$useState5 = React.useState(null),
      _React$useState6 = _slicedToArray(_React$useState5, 2),
      movementEffect = _React$useState6[0],
      setMovementEffect = _React$useState6[1];

  var elementRef = React.useRef(null);
  var transformation = (0, _useTransformationState.useTransformationState)({
    elementRef: elementRef,
    containerRef: containerRef,
    updateKey: updateKey
  });

  var getTransitionEffect = function getTransitionEffect() {
    if (removing) {
      return removingEffect;
    }

    if (lastCreated) {
      return appearingEffect;
    }

    return movementEffect;
  };

  var getTransitionDelay = function getTransitionDelay() {
    var appearingDelay = 180;
    var delayOffset = 20;

    if (removing || siblingsAmount === 0) {
      return 0;
    }

    if (lastCreated) {
      return appearingDelay;
    }
    /**
     * To simulate weightlessness we can delay the
     * transition of each item when it moves upward.
     */


    if (transformation.diffTop < 0) {
      return appearingDelay + delayOffset * index;
    }

    return 0;
  };

  (0, _useIsomorphicLayoutEffect.useIsomorphicLayoutEffect)(function () {
    if (transformation.diffTop !== 0) {
      /**
       * https://css-tricks.com/animating-layouts-with-the-flip-technique/
       */
      setMovementEffect({
        initial: {
          transform: {
            translateY: -transformation.diffTop
          }
        },
        animate: {
          transform: {
            translateY: 0,
            duration: 'moderate1'
          }
        }
      });
    }
  }, [transformation]);
  return /*#__PURE__*/React.createElement("div", {
    ref: elementRef
  }, /*#__PURE__*/React.createElement(_Transition.default, {
    active: true,
    effect: getTransitionEffect(),
    delay: getTransitionDelay(),
    onTransitionEnd: removing ? onRemove : undefined,
    fillMode: "backwards"
  }, /*#__PURE__*/React.createElement(_DummyBox.default, {
    color: "blue",
    size: "listitem",
    onClick: function onClick() {
      return setRemoving(true);
    }
  })));
};

FluidList.parameters = {
  layout: 'centered'
};