"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.SharedAxis = void 0;

var React = _interopRequireWildcard(require("react"));

var _Transition = _interopRequireDefault(require("../Transition"));

var _Flex = _interopRequireDefault(require("../../flex/Flex"));

var _Button = _interopRequireDefault(require("../../buttons/Button"));

var _Icon = _interopRequireDefault(require("../../icons/Icon"));

var _DummyBox = _interopRequireDefault(require("./common/DummyBox"));

var _Stage = _interopRequireDefault(require("./common/Stage"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

var colorsOrder = ['red', 'yellow', 'blue'];

var createSlideInEffect = function createSlideInEffect(direction) {
  return {
    initial: {
      transform: {
        translateX: direction === 'left' ? 'm' : '-m'
      },
      opacity: 0
    },
    animate: {
      transform: {
        translateX: 0
      },
      opacity: 1,
      duration: 'moderate1',
      easing: 'entry'
    }
  };
};
/**
 * An effect with only the "animate" phase always
 * performs a transition from the current position.
 */


var createSlideOutEffect = function createSlideOutEffect(direction) {
  return {
    animate: {
      transform: {
        translateX: direction === 'left' ? '-m' : 'm'
      },
      opacity: 0,
      duration: 'moderate1',
      easing: 'exit'
    }
  };
};

var SharedAxis = function SharedAxis() {
  var _React$useState = React.useState(null),
      _React$useState2 = _slicedToArray(_React$useState, 2),
      effect = _React$useState2[0],
      setEffect = _React$useState2[1];

  var _React$useState3 = React.useState(0),
      _React$useState4 = _slicedToArray(_React$useState3, 2),
      currentViewIndex = _React$useState4[0],
      setCurrentViewIndex = _React$useState4[1];

  var nextTransitionCallback = React.useRef();

  var changeView = function changeView(viewIndex) {
    if (viewIndex !== currentViewIndex) {
      var direction = currentViewIndex < viewIndex ? 'left' : 'right'; // hide previous view

      setEffect(createSlideOutEffect(direction)); // show the next view

      nextTransitionCallback.current = function () {
        setCurrentViewIndex(viewIndex);
        setEffect(createSlideInEffect(direction));
        nextTransitionCallback.current = null;
      };
    }
  };

  var handleTransitionEnd = function handleTransitionEnd() {
    if (nextTransitionCallback.current) {
      nextTransitionCallback.current();
    }
  };

  return /*#__PURE__*/React.createElement(_Stage.default, {
    centered: true
  }, /*#__PURE__*/React.createElement(_Flex.default, {
    marginBottom: "m",
    justifyContent: "center",
    className: "sg-space-x-xs"
  }, colorsOrder.map(function (color, index) {
    return /*#__PURE__*/React.createElement(_Button.default, {
      key: color,
      variant: index === currentViewIndex ? 'solid-light' : 'transparent',
      icon: /*#__PURE__*/React.createElement(_Icon.default, {
        type: "circle",
        color: buttonIconColors[color]
      }),
      onClick: function onClick() {
        return changeView(index);
      },
      iconOnly: true
    });
  })), /*#__PURE__*/React.createElement(_Transition.default, {
    active: true,
    effect: effect,
    onTransitionEnd: handleTransitionEnd
  }, /*#__PURE__*/React.createElement(_DummyBox.default, {
    size: "medium",
    color: colorsOrder[currentViewIndex]
  })));
};

exports.SharedAxis = SharedAxis;
var buttonIconColors = {
  red: 'icon-red-50',
  yellow: 'icon-yellow-50',
  blue: 'icon-blue-50'
};
SharedAxis.parameters = {
  layout: 'centered'
};