"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var React = _interopRequireWildcard(require("react"));

var _Box = _interopRequireDefault(require("../../../box/Box"));

var _Text = _interopRequireDefault(require("../../../text/Text"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var centeredStyle = {
  display: 'flex',
  alignItems: 'center'
};
var formats = {
  portrait: [320, 568],
  landscape: [640, 400],
  listitem: [250, 200]
};
var Stage = /*#__PURE__*/React.forwardRef(function (_ref, ref) {
  var children = _ref.children,
      _ref$format = _ref.format,
      format = _ref$format === void 0 ? 'landscape' : _ref$format,
      className = _ref.className,
      description = _ref.description,
      centered = _ref.centered,
      overflowHidden = _ref.overflowHidden,
      onClick = _ref.onClick;
  return /*#__PURE__*/React.createElement(_Box.default, {
    style: {
      cursor: onClick !== undefined ? 'pointer' : 'default',
      width: formats[format][0],
      height: formats[format][1],
      padding: 0
    },
    onClick: onClick,
    color: "gray-10"
  }, /*#__PURE__*/React.createElement("div", {
    ref: ref,
    style: _objectSpread({
      height: '100%',
      position: 'relative',
      overflow: overflowHidden ? 'hidden' : 'auto',
      padding: 16
    }, centered ? centeredStyle : {})
  }, /*#__PURE__*/React.createElement("div", {
    className: className,
    style: {
      margin: 'auto'
    }
  }, children), description !== undefined && /*#__PURE__*/React.createElement("div", {
    style: {
      position: 'absolute',
      textAlign: 'center',
      left: 10,
      bottom: 10,
      right: 10
    }
  }, /*#__PURE__*/React.createElement(_Text.default, {
    size: "small",
    color: "text-gray-50"
  }, description))));
});
var _default = Stage;
exports.default = _default;