"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Example = void 0;

var _react = _interopRequireDefault(require("react"));

var _useFirstPaint = require("./useFirstPaint");

require("./_use-first-paint-example.scss");

var _classnames = _interopRequireDefault(require("classnames"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

var Example = function Example() {
  var animatedElementRef = _react.default.useRef();

  var shouldAnimateRef = _react.default.useRef(false);

  var _React$useState = _react.default.useState(true),
      _React$useState2 = _slicedToArray(_React$useState, 2),
      isToggled = _React$useState2[0],
      setIsToggled = _React$useState2[1];

  var handleClick = _react.default.useCallback(function () {
    setIsToggled(!isToggled);

    if (shouldAnimateRef.current) {
      animatedElementRef.current.style.animationDuration = '';
    }
  }, [isToggled]);

  _react.default.useLayoutEffect(function () {
    animatedElementRef.current.style.animationDuration = '0ms';
  }, []);

  (0, _useFirstPaint.useFirstPaint)(function () {
    shouldAnimateRef.current = true;
  });
  return /*#__PURE__*/_react.default.createElement("div", null, /*#__PURE__*/_react.default.createElement("div", {
    style: {
      height: 300,
      width: 600
    }
  }, /*#__PURE__*/_react.default.createElement("div", {
    className: (0, _classnames.default)('use-first-paint-example-box', {
      'use-first-paint-example-box--toggled': isToggled
    }),
    onClick: handleClick,
    ref: animatedElementRef
  }, "Click me")));
};

exports.Example = Example;