import _extends from "@babel/runtime/helpers/esm/extends";
import _defineProperty from "@babel/runtime/helpers/esm/defineProperty";
import _objectWithoutProperties from "@babel/runtime/helpers/esm/objectWithoutProperties";
var _excluded = ["variant", "color", "className", "children", "width", "height", "style"];

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

import * as React from 'react';
import cx from 'classnames';
import UnstyledButton from '../buttons/UnstyledButton';
import Icon from '../icons/Icon';
export var CardButtonContext = /*#__PURE__*/React.createContext({
  color: 'dark'
});
export var CardButtonRoot = /*#__PURE__*/React.forwardRef(function (_ref, ref) {
  var _ref$variant = _ref.variant,
      variant = _ref$variant === void 0 ? 'outline' : _ref$variant,
      _ref$color = _ref.color,
      color = _ref$color === void 0 ? 'dark' : _ref$color,
      className = _ref.className,
      children = _ref.children,
      width = _ref.width,
      height = _ref.height,
      style = _ref.style,
      rest = _objectWithoutProperties(_ref, _excluded);

  var cssVariables = {
    '--card-width': width,
    '--card-height': height
  };
  return /*#__PURE__*/React.createElement(CardButtonContext.Provider, {
    value: {
      color: color
    }
  }, /*#__PURE__*/React.createElement(UnstyledButton, _extends({
    className: cx('sg-card-interactive', className),
    style: _objectSpread(_objectSpread({}, style), cssVariables),
    "data-variant": variant,
    "data-color": color
  }, rest, {
    ref: ref
  }), /*#__PURE__*/React.createElement("div", {
    className: "sg-card-interactive__border"
  }, /*#__PURE__*/React.createElement("div", {
    className: "sg-card-interactive__background"
  }, children))));
});
export var CardButtonIndicator = function CardButtonIndicator(_ref2) {
  var _ref2$slot = _ref2.slot,
      slot = _ref2$slot === void 0 ? 'top-left' : _ref2$slot,
      _ref2$size = _ref2.size,
      size = _ref2$size === void 0 ? 24 : _ref2$size,
      style = _ref2.style,
      className = _ref2.className;

  var _React$useContext = React.useContext(CardButtonContext),
      color = _React$useContext.color;

  var iconColor = color === 'light' ? 'icon-white' : 'icon-black';
  return /*#__PURE__*/React.createElement("div", {
    className: cx('sg-card-interactive__indicator', "sg-card-interactive__indicator--".concat(slot), className),
    style: style
  }, /*#__PURE__*/React.createElement("div", {
    className: "sg-card-interactive__icon"
  }, /*#__PURE__*/React.createElement(Icon, {
    type: "arrow_right",
    color: iconColor,
    size: size
  })));
};
var CardButton = Object.assign(CardButtonRoot, {
  Indicator: CardButtonIndicator
});
CardButton.displayName = 'CardButton';
CardButtonIndicator.displayName = 'CardButton.Indicator';
export default CardButton;