import _extends from "@babel/runtime/helpers/esm/extends";
import _defineProperty from "@babel/runtime/helpers/esm/defineProperty";
import _objectWithoutProperties from "@babel/runtime/helpers/esm/objectWithoutProperties";
var _excluded = ["type", "size", "color", "className"];
import * as React from 'react';
import classNames from 'classnames';
export var TYPE = {
  ANSWER_BUBBLE: 'answer_bubble',
  ARROW: 'arrow',
  ASK_BUBBLE: 'ask_bubble',
  BACKWARD_5S: 'backward_5s',
  BACKWARD_END: 'backward_end',
  BARCODE_SCANNER: 'barcode_scanner',
  BOOKMARK: 'bookmark',
  BOOKMARK_CHECKED: 'bookmark_checked',
  BOOKMARK_OUTLINED: 'bookmark_outlined',
  CHAPTER: 'chapter',
  CIRCLE_FILL: 'circle_fill',
  CLEAR: 'clear',
  COMMENT: 'comment',
  CROWN: 'crown',
  CROWN_OUTLINED: 'crown_outlined',
  CUP: 'cup',
  CURSOR_SELECT: 'cursor_select',
  DASHED_LINE: 'dashed_line',
  DRAW: 'draw',
  FILTERS: 'filters',
  FLASHLIGHT_OFF: 'flashlight_off',
  FLASHLIGHT_ON: 'flashlight_on',
  FORWARD_5S: 'forward_5s',
  HAND_MOVE: 'hand_move',
  HEART_OUTLINED: 'heart_outlined',
  HEXAGON: 'hexagon',
  INFO: 'info',
  KEYBOARD: 'keyboard',
  OPTIONS: 'options',
  REPLAY: 'replay',
  SEND_BACK: 'send_back',
  BRING_FRONT: 'bring_front',
  SHARE_ON_IOS: 'share_on_ios',
  SPARK: 'spark',
  STAR_OUTLINED: 'star_outlined',
  TEXT: 'text',
  TEXTBOOK: 'textbook',
  TIME_SPEED: 'time_speed',
  UNBOOKMARK: 'unbookmark'
};

var MobileIcon = function MobileIcon(_ref) {
  var _classNames;

  var type = _ref.type,
      _ref$size = _ref.size,
      size = _ref$size === void 0 ? 24 : _ref$size,
      _ref$color = _ref.color,
      color = _ref$color === void 0 ? 'icon-white' : _ref$color,
      className = _ref.className,
      props = _objectWithoutProperties(_ref, _excluded);

  var iconClass = classNames('sg-mobile-icon', (_classNames = {}, _defineProperty(_classNames, "sg-mobile-icon--x".concat(size), size), _defineProperty(_classNames, "sg-mobile-icon--".concat(String(color)), color), _classNames), className);
  var iconType = "#icon-mobile-".concat(type);
  return (
    /*#__PURE__*/
    // @ts-expect-error ts migration
    React.createElement("svg", _extends({}, props, {
      className: iconClass
    }), /*#__PURE__*/React.createElement("use", {
      xlinkHref: iconType
    }))
  );
};

export default MobileIcon;
export { ICON_COLOR } from '../icons/Icon';