import _extends from "@babel/runtime/helpers/esm/extends";
import _defineProperty from "@babel/runtime/helpers/esm/defineProperty";
import _objectWithoutProperties from "@babel/runtime/helpers/esm/objectWithoutProperties";
var _excluded = ["className", "children", "padding", "maxWidth", "withArrow"];

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

import * as React from 'react';
import classNames from 'classnames';
import { FloatingPortal, useMergeRefs, FloatingArrow, FloatingFocusManager } from '@floating-ui/react';
import usePopoverContext from './usePopoverContext';
var ARROW_SIZE = 24;
var ARROW_SVG_PATH = 'M0 24C1.72106 24 3.38535 23.3843 4.69205 22.2642L11.026 16.8349C11.5868 16.3542 12.414 16.3533 12.9759 16.8327L19.3782 22.2961C20.667 23.3958 22.3057 24 24 24V24L0 24V24Z';
var PopoverElement = /*#__PURE__*/React.forwardRef(function (props, ref) {
  var _context$refs$floatin, _context$y, _context$x, _context$middlewareDa;

  var className = props.className,
      children = props.children,
      padding = props.padding,
      maxWidth = props.maxWidth,
      _props$withArrow = props.withArrow,
      withArrow = _props$withArrow === void 0 ? true : _props$withArrow,
      rest = _objectWithoutProperties(props, _excluded);

  var context = usePopoverContext();
  var elementRef = useMergeRefs([context.refs.setFloating, ref]);
  if (context.hasArrow !== withArrow) context.setHasArrow(withArrow);
  var isShorterThanArrowWithPadding = ARROW_SIZE + 2 * context.arrowPadding > ((_context$refs$floatin = context.refs.floating.current) === null || _context$refs$floatin === void 0 ? void 0 : _context$refs$floatin.offsetHeight); // If the placement is right or left
  // and the popover isn't high enough to fit an arrow with the padding
  // position the arrow individually.
  // We don't care for top and bottom, because the component min width is enough to fit both arrow and it's padding.

  var arrowOffset = isShorterThanArrowWithPadding && (context.placement.includes('right') || context.placement.includes('left')) ? "calc(50% - ".concat(ARROW_SIZE / 2, "px)") : null;
  var popoverClass = classNames('sg-popover', className);
  return context.isMounted && /*#__PURE__*/React.createElement(FloatingPortal, null, /*#__PURE__*/React.createElement(FloatingFocusManager, {
    context: context.context,
    order: ['reference', 'content'],
    visuallyHiddenDismiss: true,
    initialFocus: -1
  }, /*#__PURE__*/React.createElement("div", _extends({
    ref: elementRef,
    className: popoverClass,
    "data-popover-id": context.id,
    "data-placement": context.floatingPlacement,
    "data-status": context.status,
    style: _objectSpread(_objectSpread({
      position: context.strategy,
      top: (_context$y = context.y) !== null && _context$y !== void 0 ? _context$y : 0,
      left: (_context$x = context.x) !== null && _context$x !== void 0 ? _context$x : 0,
      visibility: (_context$middlewareDa = context.middlewareData.hide) !== null && _context$middlewareDa !== void 0 && _context$middlewareDa.referenceHidden ? 'hidden' : 'visible'
    }, props.style), {}, {
      padding: padding,
      maxWidth: maxWidth
    })
  }, context.getFloatingProps(), rest), children, withArrow && /*#__PURE__*/React.createElement(FloatingArrow, {
    ref: context.arrowRef,
    className: "sg-popover__arrow",
    context: context.context,
    width: ARROW_SIZE,
    height: ARROW_SIZE,
    staticOffset: arrowOffset,
    d: ARROW_SVG_PATH
  }))));
});
export default PopoverElement;