import _extends from "@babel/runtime/helpers/esm/extends";
import _defineProperty from "@babel/runtime/helpers/esm/defineProperty";
import _objectWithoutProperties from "@babel/runtime/helpers/esm/objectWithoutProperties";
var _excluded = ["size", "color", "className"];
import * as React from 'react';
import classNames from 'classnames';
export var SIZE = {
  NORMAL: 'normal',
  SMALL: 'small',
  LARGE: 'large',
  FULL: 'full'
};
export var COLORS_MAP = {
  white: 'white',
  'gray-50': 'gray-50',
  'gray-40': 'gray-40'
};

var Separator = function Separator(_ref) {
  var _classNames;

  var _ref$size = _ref.size,
      size = _ref$size === void 0 ? SIZE.NORMAL : _ref$size,
      _ref$color = _ref.color,
      color = _ref$color === void 0 ? COLORS_MAP['gray-40'] : _ref$color,
      className = _ref.className,
      props = _objectWithoutProperties(_ref, _excluded);

  var separatorClass = classNames('sg-vertical-separator', (_classNames = {}, _defineProperty(_classNames, "sg-vertical-separator--".concat(size), size !== SIZE.NORMAL), _defineProperty(_classNames, "sg-vertical-separator--".concat(String(color)), color), _classNames), className);
  return /*#__PURE__*/React.createElement("div", _extends({}, props, {
    className: separatorClass,
    role: "separator",
    "aria-orientation": "vertical"
  }));
};

export default Separator;