import _defineProperty from "@babel/runtime/helpers/esm/defineProperty";

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

import * as React from 'react';
import Box from '../../../box/Box';
import Button from '../../../buttons/Button';
import Icon from '../../../icons/Icon';
var sizes = {
  listitem: {
    width: 'auto',
    height: 48
  },
  small: {
    width: 150,
    height: 100
  },
  medium: {
    width: 300,
    height: 200
  },
  large: {
    width: 600,
    height: 400
  }
};
var colors = {
  red: 'red-40',
  yellow: 'yellow-40',
  blue: 'blue-40'
};
var DummyBox = /*#__PURE__*/React.forwardRef(function (_ref, ref) {
  var size = _ref.size,
      color = _ref.color,
      onClick = _ref.onClick;
  return /*#__PURE__*/React.createElement(Box, {
    ref: ref,
    color: colors[color],
    padding: "xs",
    onClick: onClick,
    style: _objectSpread(_objectSpread({}, sizes[size]), {}, {
      cursor: onClick === undefined ? 'default' : 'pointer'
    })
  }, onClick !== undefined && size === 'listitem' && /*#__PURE__*/React.createElement(Button, {
    size: "s",
    icon: /*#__PURE__*/React.createElement(Icon, {
      type: "close",
      size: 24
    }),
    variant: "transparent-inverted",
    iconOnly: true
  }));
});
export default DummyBox;