import _defineProperty from "@babel/runtime/helpers/esm/defineProperty";

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

import * as React from 'react';
import Box from '../../../box/Box';
import Text from '../../../text/Text';
var centeredStyle = {
  display: 'flex',
  alignItems: 'center'
};
var formats = {
  portrait: [320, 568],
  landscape: [640, 400],
  listitem: [250, 200]
};
var Stage = /*#__PURE__*/React.forwardRef(function (_ref, ref) {
  var children = _ref.children,
      _ref$format = _ref.format,
      format = _ref$format === void 0 ? 'landscape' : _ref$format,
      className = _ref.className,
      description = _ref.description,
      centered = _ref.centered,
      overflowHidden = _ref.overflowHidden,
      onClick = _ref.onClick;
  return /*#__PURE__*/React.createElement(Box, {
    style: {
      cursor: onClick !== undefined ? 'pointer' : 'default',
      width: formats[format][0],
      height: formats[format][1],
      padding: 0
    },
    onClick: onClick,
    color: "gray-10"
  }, /*#__PURE__*/React.createElement("div", {
    ref: ref,
    style: _objectSpread({
      height: '100%',
      position: 'relative',
      overflow: overflowHidden ? 'hidden' : 'auto',
      padding: 16
    }, centered ? centeredStyle : {})
  }, /*#__PURE__*/React.createElement("div", {
    className: className,
    style: {
      margin: 'auto'
    }
  }, children), description !== undefined && /*#__PURE__*/React.createElement("div", {
    style: {
      position: 'absolute',
      textAlign: 'center',
      left: 10,
      bottom: 10,
      right: 10
    }
  }, /*#__PURE__*/React.createElement(Text, {
    size: "small",
    color: "text-gray-50"
  }, description))));
});
export default Stage;